//+------------------------------------------------------------------+
//|                                                   Bands+Fibo.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 Blue 
#property indicator_color2 Green
#property indicator_color3 Green
#property indicator_color4 Red 
#property indicator_color5 LightSeaGreen
#property indicator_color6 Red
#property indicator_color7 LightSeaGreen
#property indicator_style1 STYLE_DOT
#property indicator_width5 2
#property indicator_width7 2


//---- indicator parameters
extern int    BandsPeriod = 20;
extern int    BandsMode   = MODE_SMA;
extern int    BandsShift  = 0;
extern double Level1      = 1.618;
extern double Level2      = 2.618;
extern double Level3      = 4.236;
extern int    ATRPeriods  = 20;
extern int    ATRShift    = 0;
//---- buffers
double MovingBuffer[];
double UpperBuffer[];
double UpperBuffer2[];
double UpperBuffer3[];
double LowerBuffer[];
double LowerBuffer2[];
double LowerBuffer3[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexBuffer(0,MovingBuffer);
   SetIndexBuffer(1,UpperBuffer);
   SetIndexBuffer(2,LowerBuffer);
   SetIndexBuffer(3,UpperBuffer2);
   SetIndexBuffer(4,UpperBuffer3);
   SetIndexBuffer(5,LowerBuffer2);
   SetIndexBuffer(6,LowerBuffer3);
//----
   SetIndexDrawBegin(0,BandsPeriod+BandsShift);
   SetIndexDrawBegin(1,BandsPeriod+BandsShift);
   SetIndexDrawBegin(2,BandsPeriod+BandsShift);
   SetIndexDrawBegin(3,BandsPeriod+BandsShift);
   SetIndexDrawBegin(4,BandsPeriod+BandsShift);
   SetIndexDrawBegin(5,BandsPeriod+BandsShift);
   SetIndexDrawBegin(6,BandsPeriod+BandsShift);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Bollinger Bands                                                  |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           
   for(int i=0; i<limit; i++)
   {
      MovingBuffer[i]=iMA(NULL,0,BandsPeriod,BandsShift,BandsMode,PRICE_CLOSE,i);
      double oldval    = MovingBuffer[i];
      double deviation = iATR(NULL,0,ATRPeriods,i+ATRShift);
      if (Level1>0) UpperBuffer[i] =oldval+deviation*Level1;
      if (Level2>0) UpperBuffer2[i]=oldval+deviation*Level2;
      if (Level3>0) UpperBuffer3[i]=oldval+deviation*Level3;
      if (Level1>0) LowerBuffer[i] =oldval-deviation*Level1;
      if (Level2>0) LowerBuffer2[i]=oldval-deviation*Level2;
      if (Level3>0) LowerBuffer3[i]=oldval-deviation*Level3; 
   }
   return(0);
}

